var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import * as React from "react";
import AfterpayProvider, { useAfterpay } from "../../contexts/afterpay/afterpay.es.js";
export { AfterpayContext, default as AfterpayProvider } from "../../contexts/afterpay/afterpay.es.js";
import { useEventListener } from "../../hooks/use-event-listener.es.js";
import { useForm } from "../../contexts/form/form.es.js";
import { ButtonLoader } from "./afterpay.styles.es.js";
function AfterpayButton(_a) {
  var _b = _a, {
    Button,
    buttonColor = "black",
    buttonType = "buy_now_with_afterpay",
    finalCtaButtonType = "buy_now",
    id = "rswps-afterpay-button"
  } = _b, props = __objRest(_b, [
    "Button",
    "buttonColor",
    "buttonType",
    "finalCtaButtonType",
    "id"
  ]);
  const containerRef = React.useRef(null);
  const afterpay = useAfterpay();
  const { cardTokenizeResponseReceived } = useForm();
  const options = React.useMemo(() => ({
    buttonColor,
    buttonType,
    finalCtaButtonType,
    useCustomButton: Boolean(Button)
  }), [Button, buttonColor, buttonType, finalCtaButtonType]);
  const handlePayment = (e) => __async(this, null, function* () {
    e.stopPropagation();
    if (!afterpay) {
      console.warn("Afterpay/Clearpay button was clicked, but no Afterpay/Clearpay instance was found.");
      return;
    }
    try {
      const result = yield afterpay.tokenize();
      if (result.status === "OK") {
        return cardTokenizeResponseReceived(result);
      }
      let message = `Tokenization failed with status: ${result == null ? void 0 : result.status}`;
      if (result == null ? void 0 : result.errors) {
        message += ` and errors: ${JSON.stringify(result == null ? void 0 : result.errors)}`;
        throw new Error(message);
      }
      console.warn(message);
    } catch (error) {
      console.error(error);
    }
  });
  React.useEffect(() => {
    if (afterpay) {
      afterpay == null ? void 0 : afterpay.attach(`#${id}`, options);
    }
    return () => {
      if (afterpay) {
        afterpay == null ? void 0 : afterpay.destroy();
      }
    };
  }, [afterpay]);
  useEventListener({
    listener: handlePayment,
    type: "click",
    element: containerRef,
    options: {
      passive: true
    }
  });
  if (Button) {
    return /* @__PURE__ */ React.createElement(Button, __spreadProps(__spreadValues({}, props), {
      id,
      ref: containerRef
    }));
  }
  return /* @__PURE__ */ React.createElement("div", __spreadProps(__spreadValues({}, props), {
    id,
    ref: containerRef
  }), !afterpay ? /* @__PURE__ */ React.createElement(ButtonLoader, null) : null);
}
function AfterpayMessage(_c) {
  var _d = _c, {
    badgeTheme = "black-on-mint",
    component,
    id = "rswps-afterpay-message",
    modalLinkStyle = "circled-info-icon",
    modalTheme = "mint",
    size = "md"
  } = _d, props = __objRest(_d, [
    "badgeTheme",
    "component",
    "id",
    "modalLinkStyle",
    "modalTheme",
    "size"
  ]);
  const messageRef = React.useRef(null);
  const afterpay = useAfterpay();
  const options = React.useMemo(() => ({
    badgeTheme,
    modalLinkStyle,
    modalTheme,
    size
  }), [badgeTheme, modalLinkStyle, modalTheme, size]);
  React.useEffect(() => {
    const start = () => __async(this, null, function* () {
      yield afterpay == null ? void 0 : afterpay.attachMessaging(`#${id}`, options);
    });
    if (afterpay && !(component == null ? void 0 : component.Message)) {
      start();
    }
  }, [afterpay, component == null ? void 0 : component.Message, options]);
  const onClick = (e) => __async(this, null, function* () {
    e.stopPropagation();
    afterpay == null ? void 0 : afterpay.displayInformationModal({ modalTheme });
  });
  useEventListener({
    listener: onClick,
    type: "click",
    element: messageRef,
    options: {
      passive: true
    }
  });
  const Message = component == null ? void 0 : component.Message;
  if (Message) {
    return /* @__PURE__ */ React.createElement(Message, __spreadProps(__spreadValues({}, props), {
      id,
      ref: messageRef
    }));
  }
  return /* @__PURE__ */ React.createElement("div", __spreadProps(__spreadValues({}, props), {
    id
  }));
}
function AfterpayWidget(_e) {
  var _f = _e, { includeBranding, id = "rswps-afterpay-widget" } = _f, props = __objRest(_f, ["includeBranding", "id"]);
  const containerRef = React.useRef(null);
  const afterpay = useAfterpay();
  React.useEffect(() => {
    const start = () => __async(this, null, function* () {
      yield afterpay == null ? void 0 : afterpay.attachCheckoutWidget(`#${id}`, {
        includeBranding
      });
    });
    if (afterpay) {
      start();
    }
  }, [afterpay, includeBranding]);
  return /* @__PURE__ */ React.createElement("div", __spreadProps(__spreadValues({}, props), {
    id,
    ref: containerRef
  }));
}
function Afterpay(props) {
  return /* @__PURE__ */ React.createElement(AfterpayProvider, null, /* @__PURE__ */ React.createElement(AfterpayButton, __spreadValues({}, props)));
}
export { AfterpayButton, AfterpayMessage, AfterpayWidget, Afterpay as default };
//# sourceMappingURL=afterpay.es.js.map
