var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import * as React from "react";
import { useForm } from "../../contexts/form/form.es.js";
function CashAppPay(_a) {
  var _b = _a, {
    callbacks,
    id = "rswps-cash-app-pay",
    redirectURL,
    referenceId,
    shape = "round",
    size = "medium",
    values = "dark",
    width = "static"
  } = _b, props = __objRest(_b, [
    "callbacks",
    "id",
    "redirectURL",
    "referenceId",
    "shape",
    "size",
    "values",
    "width"
  ]);
  const [cashApp, setCashApp] = React.useState();
  const { createPaymentRequest, payments } = useForm();
  const paymentRequestOptions = React.useMemo(() => ({
    redirectURL: redirectURL || window.location.href,
    referenceId
  }), [redirectURL, referenceId]);
  const options = React.useMemo(() => {
    const baseOptions = {
      shape,
      size,
      values,
      width
    };
    return Object.keys(baseOptions).reduce((acc, key) => {
      if (baseOptions[key] !== void 0) {
        acc[key] = baseOptions[key];
      }
      return acc;
    }, {});
  }, [shape, size, values, width]);
  React.useEffect(() => {
    if (!createPaymentRequest) {
      throw new Error("`createPaymentRequest()` is required when using digital wallets");
    }
    const abortController = new AbortController();
    const { signal } = abortController;
    const start = (signal2) => __async(this, null, function* () {
      const paymentRequest = payments == null ? void 0 : payments.paymentRequest(createPaymentRequest);
      if (!paymentRequest) {
        throw new Error("`paymentRequest` is required when using digital wallets");
      }
      try {
        const cashApp2 = yield payments == null ? void 0 : payments.cashAppPay(paymentRequest, paymentRequestOptions).then((res) => {
          if (signal2 == null ? void 0 : signal2.aborted) {
            return;
          }
          setCashApp(res);
          return res;
        });
        yield cashApp2 == null ? void 0 : cashApp2.attach(`#${id}`, options);
        if (signal2.aborted) {
          yield cashApp2 == null ? void 0 : cashApp2.destroy();
        }
      } catch (error) {
        console.error("Initializing Cash App Pay failed", error);
      }
    });
    start(signal);
    return () => {
      abortController.abort();
    };
  }, [createPaymentRequest, options, paymentRequestOptions, payments]);
  if (callbacks) {
    for (const callback of Object.keys(callbacks)) {
      cashApp == null ? void 0 : cashApp.addEventListener(callback.toLowerCase(), callbacks[callback]);
    }
  }
  return /* @__PURE__ */ React.createElement("div", __spreadProps(__spreadValues({}, props), {
    id
  }));
}
export { CashAppPay as default };
//# sourceMappingURL=cash-app-pay.es.js.map
