var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import * as React from "react";
import { useForm } from "../../contexts/form/form.es.js";
import { useEventListener } from "../../hooks/use-event-listener.es.js";
import { LoadingCard, PayButton } from "./gift-card.styles.es.js";
function GiftCard(_a) {
  var _b = _a, {
    buttonProps = {
      id: "rswps-gift-card-button"
    },
    callbacks,
    children,
    focus,
    id = "rswps-gift-card-container",
    includeInputLabels,
    render,
    style
  } = _b, props = __objRest(_b, [
    "buttonProps",
    "callbacks",
    "children",
    "focus",
    "id",
    "includeInputLabels",
    "render",
    "style"
  ]);
  const [giftCard, setGiftCard] = React.useState(() => void 0);
  const [isSubmitting, setIsSubmitting] = React.useState(false);
  const { cardTokenizeResponseReceived, payments } = useForm();
  const buttonRef = React.useRef(null);
  const options = React.useMemo(() => {
    const baseOptions = {
      includeInputLabels,
      style
    };
    return Object.keys(baseOptions).reduce((acc, key) => {
      if (baseOptions[key] !== void 0) {
        acc[key] = baseOptions[key];
      }
      return acc;
    }, {});
  }, [includeInputLabels, style]);
  const handlePayment = (e) => __async(this, null, function* () {
    e.stopPropagation();
    if (!giftCard) {
      console.warn("Gift Card button was clicked, but no Gift Card instance was found.");
      return;
    }
    setIsSubmitting(true);
    try {
      const result = yield giftCard == null ? void 0 : giftCard.tokenize();
      if (result.status === "OK") {
        const tokenizedResult = yield cardTokenizeResponseReceived(result);
        return tokenizedResult;
      }
      let message = `Tokenization failed with status: ${result.status}`;
      if (result == null ? void 0 : result.errors) {
        message += ` and errors: ${JSON.stringify(result == null ? void 0 : result.errors)}`;
        throw new Error(message);
      }
      console.warn(message);
    } catch (error) {
      console.error(error);
    } finally {
      setIsSubmitting(false);
    }
  });
  React.useEffect(() => {
    const abortController = new AbortController();
    const { signal } = abortController;
    const start = (signal2) => __async(this, null, function* () {
      const giftCard2 = yield payments == null ? void 0 : payments.giftCard(options).then((res) => {
        if (!signal2.aborted) {
          setGiftCard(res);
          return res;
        }
        return null;
      });
      yield giftCard2 == null ? void 0 : giftCard2.attach(`#${id}`);
      if (focus) {
        yield giftCard2 == null ? void 0 : giftCard2.focus(focus);
      }
      if (signal2.aborted) {
        yield giftCard2 == null ? void 0 : giftCard2.destroy();
      }
    });
    start(signal);
    return () => {
      abortController.abort();
    };
  }, [payments, id]);
  if (callbacks) {
    for (const callback of Object.keys(callbacks)) {
      giftCard == null ? void 0 : giftCard.addEventListener(callback, callbacks[callback]);
    }
  }
  useEventListener({
    listener: handlePayment,
    type: "click",
    element: buttonRef,
    options: {
      passive: true
    }
  });
  const Button = (_a2) => {
    var _b2 = _a2, { isLoading } = _b2, props2 = __objRest(_b2, ["isLoading"]);
    var _a3;
    const id2 = "rswp-gift-card-button";
    const disabled = isLoading || !giftCard || isSubmitting;
    return /* @__PURE__ */ React.createElement(PayButton, __spreadProps(__spreadValues({}, props2), {
      "aria-disabled": disabled,
      css: props2 == null ? void 0 : props2.css,
      disabled,
      id: id2,
      ref: buttonRef,
      type: "button"
    }), (_a3 = props2 == null ? void 0 : props2.children) != null ? _a3 : "Pay with Gift Card");
  };
  return /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement("div", __spreadProps(__spreadValues({}, props), {
    "data-testid": "rswps-gift-card-container",
    id,
    style: { minHeight: 89 }
  }), !giftCard && /* @__PURE__ */ React.createElement(LoadingCard, null)), typeof render === "function" ? render(Button) : /* @__PURE__ */ React.createElement(Button, __spreadValues({}, buttonProps), children != null ? children : "Pay with Gift Card"));
}
export { GiftCard as default };
//# sourceMappingURL=gift-card.es.js.map
