var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import * as React from "react";
import { useForm } from "../../contexts/form/form.es.js";
import { useEventListener } from "../../hooks/use-event-listener.es.js";
import { ButtonLoader } from "./google-pay.styles.es.js";
const GooglePay = (_a) => {
  var _b = _a, {
    buttonColor,
    buttonSizeMode = "fill",
    buttonType = "long",
    id = "rswps-google-pay-container"
  } = _b, props = __objRest(_b, [
    "buttonColor",
    "buttonSizeMode",
    "buttonType",
    "id"
  ]);
  const [googlePay, setGooglePay] = React.useState(() => void 0);
  const { cardTokenizeResponseReceived, createPaymentRequest, payments } = useForm();
  const containerRef = React.useRef(null);
  const options = React.useMemo(() => {
    const baseOptions = {
      buttonColor,
      buttonSizeMode,
      buttonType
    };
    return Object.keys(baseOptions).reduce((acc, key) => {
      if (baseOptions[key] !== void 0) {
        acc[key] = baseOptions[key];
      }
      return acc;
    }, {});
  }, [buttonColor, buttonSizeMode, buttonType]);
  const handlePayment = (e) => __async(this, null, function* () {
    e.stopPropagation();
    if (!googlePay) {
      console.warn("Google Pay button was clicked, but no Google Pay instance was found.");
      return;
    }
    try {
      const result = yield googlePay.tokenize();
      if (result.status === "OK") {
        return cardTokenizeResponseReceived(result);
      }
      let message = `Tokenization failed with status: ${result.status}`;
      if (result == null ? void 0 : result.errors) {
        message += ` and errors: ${JSON.stringify(result == null ? void 0 : result.errors)}`;
        throw new Error(message);
      }
      console.warn(message);
    } catch (error) {
      console.error(error);
    }
  });
  React.useEffect(() => {
    if (!createPaymentRequest) {
      throw new Error("`createPaymentRequest()` is required when using digital wallets");
    }
    const abortController = new AbortController();
    const { signal } = abortController;
    const start = (signal2) => __async(this, null, function* () {
      const paymentRequest = payments == null ? void 0 : payments.paymentRequest(createPaymentRequest);
      if (!paymentRequest) {
        throw new Error("`paymentRequest` is required when using digital wallets");
      }
      try {
        const googlePay2 = yield payments == null ? void 0 : payments.googlePay(paymentRequest).then((res) => {
          if (signal2 == null ? void 0 : signal2.aborted) {
            return;
          }
          setGooglePay(res);
          return res;
        });
        yield googlePay2 == null ? void 0 : googlePay2.attach(`#${id}`, options);
        if (signal2.aborted) {
          yield googlePay2 == null ? void 0 : googlePay2.destroy();
        }
      } catch (error) {
        console.error("Initializing Google Pay failed", error);
      }
    });
    start(signal);
    return () => {
      abortController.abort();
    };
  }, [createPaymentRequest, payments, options]);
  useEventListener({
    listener: handlePayment,
    type: "click",
    element: containerRef,
    options: {
      passive: true
    }
  });
  return /* @__PURE__ */ React.createElement("div", __spreadProps(__spreadValues({}, props), {
    id,
    ref: containerRef
  }), !googlePay ? /* @__PURE__ */ React.createElement(ButtonLoader, null) : null);
};
export { GooglePay as default };
//# sourceMappingURL=google-pay.es.js.map
