var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
import * as React from "react";
import { payments } from "../../node_modules/@square/web-sdk/dist/payments.es.js";
import ErrorScreen from "../../components/error-screen/error-screen.es.js";
import { useDynamicCallback } from "../../hooks/use-dynamic-callback.es.js";
const FormContext = React.createContext({
  cardTokenizeResponseReceived: null,
  createPaymentRequest: null,
  payments: null
});
function FormProvider(_a) {
  var _b = _a, { applicationId, locationId, children, overrides } = _b, props = __objRest(_b, ["applicationId", "locationId", "children", "overrides"]);
  const [instance, setInstance] = React.useState();
  const [createPaymentRequest] = React.useState(() => {
    var _a2;
    return (_a2 = props.createPaymentRequest) == null ? void 0 : _a2.call(props);
  });
  React.useEffect(() => {
    const abortController = new AbortController();
    const { signal } = abortController;
    function loadPayment(signal2) {
      return __async(this, null, function* () {
        yield payments(applicationId, locationId, overrides).then((res) => {
          if (res === null) {
            throw new Error("Square Web Payments SDK failed to load");
          }
          if (signal2 == null ? void 0 : signal2.aborted) {
            return;
          }
          setInstance(res);
          return res;
        });
      });
    }
    if (applicationId && locationId) {
      loadPayment(signal);
    }
    return () => {
      abortController.abort();
    };
  }, [applicationId, locationId]);
  const cardTokenizeResponseReceived = (rest) => __async(this, null, function* () {
    if (rest.errors || !props.createVerificationDetails) {
      yield props.cardTokenizeResponseReceived(rest);
      return;
    }
    const verifyBuyerResults = yield instance == null ? void 0 : instance.verifyBuyer(String(rest.token), props.createVerificationDetails());
    yield props.cardTokenizeResponseReceived(rest, verifyBuyerResults);
  });
  const cardTokenizeResponseReceivedCallback = useDynamicCallback(cardTokenizeResponseReceived);
  if (!applicationId || !locationId) {
    return /* @__PURE__ */ React.createElement(ErrorScreen, null);
  }
  if (!instance)
    return null;
  const context = {
    cardTokenizeResponseReceived: cardTokenizeResponseReceivedCallback,
    createPaymentRequest,
    payments: instance
  };
  return /* @__PURE__ */ React.createElement(FormContext.Provider, {
    value: context
  }, children);
}
const useForm = () => {
  const context = React.useContext(FormContext);
  if (context === void 0) {
    throw new Error("useForm must be used within a FormProvider");
  }
  return context;
};
export { FormContext, FormProvider as default, useForm };
//# sourceMappingURL=form.es.js.map
