var _a;
import * as React from "react";
const getRefElement = (element) => {
  if (element && "current" in element) {
    return element.current;
  }
  return element;
};
const isSsr = !(typeof window !== "undefined" && ((_a = window.document) == null ? void 0 : _a.createElement));
function useEventListener({ type, listener, element = isSsr ? void 0 : window, options }) {
  const savedListener = React.useRef();
  React.useEffect(() => {
    savedListener.current = listener;
  }, [listener]);
  const handleEventListener = React.useCallback((event) => {
    var _a2;
    (_a2 = savedListener.current) == null ? void 0 : _a2.call(savedListener, event);
  }, []);
  React.useEffect(() => {
    const target = getRefElement(element);
    target == null ? void 0 : target.addEventListener(type, handleEventListener, options);
    return () => target == null ? void 0 : target.removeEventListener(type, handleEventListener);
  }, [type, element, options, handleEventListener]);
}
export { getRefElement, useEventListener };
//# sourceMappingURL=use-event-listener.es.js.map
